// USBDII.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>
#include <time.h>
#include "usb100.h"
#include <setupapi.h>
#include "USBDII.h"
extern "C" {
#include "hidsdi.h"
#include "hidusage.h"
}


#ifdef _MANAGED
#pragma managed(push, off)
#endif
enum {ereport_ID = 0};
enum {eCard_ID = 1,eCard_Num = 2,eport1 = 3,eport2 = 4,
	eport3 = 5,eport4 = 6,eadc_index = 7,elower_adc_result = 8,eupper_adc_result = 9};
enum {eDIO_address = 1,eDIO_data = 2,eChipSel = 3,eControl = 4};

unsigned char in_buffer[64];
unsigned char out_buffer[64];

#define Composite_Device_VID		0x16C0
#define Composite_Device_PID		0x06EE

#define HID_Device_VID		0x10C4
#define HID_Device_PID		0x81B9 // ( - 0x81BF)

BOOL m_bWriteError = FALSE;
BOOL m_bReadError = FALSE;
unsigned long ulBytesSucceed;
unsigned long ulBytesWriteRequest;
unsigned long ulBytesReadRequest;
HIDP_CAPS caps;
PHIDP_PREPARSED_DATA preparsed;


// for COM Port

unsigned char seg = 0;
unsigned char rseg = 0;
UINT com_card_id,com_card_number;

// for init set

BOOL Init_Mode = false;

/*
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}
*/
HANDLE WINAPI hid_open(UINT card_id,UINT card_number)
{
	unsigned short vendorID, productID;
	unsigned long in_report_buflen, out_report_buflen;
	
	//0x02 is labkit,
	//it is a composite device,different from others
	if(card_id == 0x02 || card_id == 0x04)
	{
		vendorID = Composite_Device_VID;
		productID = Composite_Device_PID;
	}
	else
	{
		vendorID = HID_Device_VID;
		productID = HID_Device_PID;
	}

	//reset
	BOOL bRet = FALSE;
	wchar_t	m_DeviceName[256];
	wchar_t mString_1[256];
	wchar_t mString_2[256];
	wchar_t mString_3[256];
	HANDLE hUSB;

	hUSB = INVALID_HANDLE_VALUE;

	// Set HID GUID							<-- modify for HID
	GUID HidGuid;
	HidD_GetHidGuid( &HidGuid );
	memset(m_DeviceName, 0, sizeof(m_DeviceName));

	// Retrieve device list for GUID that has been specified.
	HDEVINFO hDevInfoList = SetupDiGetClassDevs (&HidGuid, NULL, NULL, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE)); 

	if (hDevInfoList != INVALID_HANDLE_VALUE)
	{
		SP_DEVICE_INTERFACE_DATA deviceInfoData;

		for (int MemberIndex = 0; MemberIndex < 127; MemberIndex++)
		{
			// Clear data structure
			ZeroMemory(&deviceInfoData, sizeof(deviceInfoData));
			deviceInfoData.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);

			// retrieves a context structure for a device interface of a device information set.
			if (SetupDiEnumDeviceInterfaces (hDevInfoList, 0, &HidGuid, MemberIndex, &deviceInfoData)) 
			{
				// Must get the detailed information in two steps
				// First get the length of the detailed information and allocate the buffer
				// retrieves detailed information about a specified device interface.
				PSP_DEVICE_INTERFACE_DETAIL_DATA     functionClassDeviceData = NULL;
				ULONG  predictedLength, requiredLength;
				predictedLength = requiredLength = 0;
				SetupDiGetDeviceInterfaceDetail (
						hDevInfoList,
						&deviceInfoData,
						NULL,			// Not yet allocated
						0,				// Set output buffer length to zero 
						&requiredLength,// Find out memory requirement
						NULL);			

				predictedLength = requiredLength;
				functionClassDeviceData = (PSP_DEVICE_INTERFACE_DETAIL_DATA)malloc (predictedLength);
				functionClassDeviceData->cbSize = sizeof (SP_DEVICE_INTERFACE_DETAIL_DATA);

				// Second, get the detailed information
				if ( SetupDiGetDeviceInterfaceDetail (
							hDevInfoList,
							&deviceInfoData,
							functionClassDeviceData,
							predictedLength,
							&requiredLength,
							NULL)) 
				{

					// for HID device, matching GUID is not enough to specify the device
					// Check VID/PID too
					HANDLE hDevice = CreateFile(
										functionClassDeviceData->DevicePath,
										GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, 
										(LPSECURITY_ATTRIBUTES)NULL, OPEN_EXISTING, 0, NULL );

					if ( hDevice != INVALID_HANDLE_VALUE ) {
						// Read out attribute, which knows VID/PID
						HIDD_ATTRIBUTES attributes;
						attributes.Size = sizeof(attributes);
						HidD_GetAttributes( hDevice, &attributes );
						
						HidD_GetManufacturerString(hDevice, mString_1, 256);
						HidD_GetProductString(hDevice, mString_2, 256);
						HidD_GetSerialNumberString(hDevice, mString_3, 256);

						// Check VID/PID
						if ( (attributes.VendorID  == vendorID) && (attributes.ProductID == productID) ){

							// Save the device name for subsequent pipe open calls
							wcscpy( m_DeviceName, (unsigned short *)functionClassDeviceData->DevicePath);
					    	
							HidD_GetManufacturerString(hDevice, mString_1, 256);
							HidD_GetProductString(hDevice, mString_2, 256);
							HidD_GetSerialNumberString(hDevice, mString_3, 256);

							hUSB = CreateFile(	(char *)m_DeviceName,
												GENERIC_WRITE | GENERIC_READ,
												FILE_SHARE_WRITE | FILE_SHARE_READ,
												NULL,
												OPEN_EXISTING,
												0,
												NULL);

							if(hUSB == INVALID_HANDLE_VALUE)
							{
								bRet = FALSE;
								break;
							}

							// get I/O buffer size for HID IN/OUT endpoint access
							HidD_GetPreparsedData( hUSB, &preparsed );
							HidP_GetCaps( preparsed, &caps );
							in_report_buflen  = caps.InputReportByteLength;
							out_report_buflen = caps.OutputReportByteLength;

							ulBytesWriteRequest = out_report_buflen;
							ulBytesReadRequest = in_report_buflen;

							out_buffer[ereport_ID] = 0x00;
							in_buffer[ereport_ID] = 0x00;

							ReadFile(hUSB, &in_buffer, ulBytesReadRequest, &ulBytesSucceed, NULL);
							if( (ulBytesSucceed != ulBytesReadRequest) && (m_bReadError == FALSE) )
							{
								m_bReadError = TRUE;	// Note: Set error flag immediately so that multiple 
														// message boxes do not queue up.

								bRet = FALSE;
								break;
							}

							if((card_id == in_buffer[eCard_ID])&&(card_number == in_buffer[eCard_Num]))
							{
/*
								for(int index = 0; index<4; index++)
								{
									out_buffer[eDIO_address] = index;
									out_buffer[eDIO_data] = 0x00;
								
									WriteFile(hUSB, &out_buffer, ulBytesWriteRequest, &ulBytesSucceed, NULL);
									if(ulBytesSucceed != ulBytesWriteRequest)
									{
										m_bWriteError = TRUE;	// Note: Set error flag immediately so that multiple 
																// message boxes do not queue up.
										bRet = FALSE;
										break;
									}
								}
*/
								bRet = TRUE;
							}							
						}
						CloseHandle( hDevice );
					}
				}

				free( functionClassDeviceData );

				if ( bRet )
					break;
			}
			else
			{
					DWORD error = GetLastError();

				if ( GetLastError() == ERROR_NO_MORE_ITEMS ) 
				{
					break;
				}
			}
		}
		
		// SetupDiDestroyDeviceInfoList() destroys a device information set
		// and frees all associated memory.

		SetupDiDestroyDeviceInfoList (hDevInfoList);

		if(!bRet)	
			return INVALID_HANDLE_VALUE;
		else
			return hUSB;
	}
	else
	{
			return INVALID_HANDLE_VALUE;
	}
}

BOOL WINAPI hid_write(HANDLE hUSB, UINT address, BYTE data)
{

	// avoid user init setting   
	if(address > 3 && Init_Mode == FALSE) return FALSE;

	out_buffer[eDIO_address] = address;
	out_buffer[eDIO_data] = data;

	WriteFile(hUSB, &out_buffer, ulBytesWriteRequest, &ulBytesSucceed, NULL);
	if(ulBytesSucceed != ulBytesWriteRequest)
	{
		m_bWriteError = TRUE;	// Note: Set error flag immediately so that multiple 
								// message boxes do not queue up.
//		printf("Error writing to USB.\nWrote %d of %d bytes.\n\nApplication is aborting.\nReset hardware and try again.", ulBytesSucceed, ulBytesWriteRequest);
//		system("pause");
		return FALSE;
	}

	return TRUE;
}

BOOL WINAPI hid_write_with_command(HANDLE hUSB, UINT address, BYTE data ,BYTE cs, BYTE command)
{
	out_buffer[eDIO_address] = address;
	out_buffer[eDIO_data] = data;
	out_buffer[eChipSel] = cs;
	out_buffer[eControl] = command;

	WriteFile(hUSB, &out_buffer, ulBytesWriteRequest, &ulBytesSucceed, NULL);
	if(ulBytesSucceed != ulBytesWriteRequest)
	{
		m_bWriteError = TRUE;	// Note: Set error flag immediately so that multiple 
								// message boxes do not queue up.
//		printf("Error writing to USB.\nWrote %d of %d bytes.\n\nApplication is aborting.\nReset hardware and try again.", ulBytesSucceed, ulBytesWriteRequest);
//		system("pause");
		return FALSE;
	}

	return TRUE;
}

BOOL WINAPI hid_read_with_cs(HANDLE hUSB, UINT address, BYTE *data ,BYTE cs)
{
	if(hid_write_with_command(hUSB,address,0 ,cs, 0x02)){
		ReadFile(hUSB, &in_buffer, ulBytesReadRequest, &ulBytesSucceed, NULL);
		if( (ulBytesSucceed != ulBytesReadRequest) && (m_bReadError == FALSE) ){
		m_bReadError = TRUE;	// Note: Set error flag immediately so that multiple 
								// message boxes do not queue up.

	//		printf("Error reading from USB.\nRead %d of %d bytes.\n\nApplication is aborting.\nReset hardware and try again.", ulBytesSucceed, ulBytesReadRequest);
	//		system("pause");
		return FALSE;
		}
		if(cs == 0x04)//8255
			*data = in_buffer[eCard_Num+1+address+4];
		else//8254
			*data = in_buffer[eCard_Num+1+address];
		return TRUE;
	}
	else
		return FALSE;
}

BOOL WINAPI hid_read(HANDLE hUSB, UINT address, BYTE *data)
{
   
	int index = 0;
	for(int i = 0; i<64;i++){
		in_buffer[i] = i;
	}

	ReadFile(hUSB, &in_buffer, ulBytesReadRequest, &ulBytesSucceed, NULL);
	if( (ulBytesSucceed != ulBytesReadRequest) && (m_bReadError == FALSE) )
	{
		m_bReadError = TRUE;	// Note: Set error flag immediately so that multiple 
								// message boxes do not queue up.

//		printf("Error reading from USB.\nRead %d of %d bytes.\n\nApplication is aborting.\nReset hardware and try again.", ulBytesSucceed, ulBytesReadRequest);
//		system("pause");
		return FALSE;
	}

	*data = in_buffer[eport1 + address];


	return TRUE;
}

BOOL WINAPI hid_GetAnalogChannel(HANDLE hUSB, UINT address, ULONG *data)
{
	if(m_bReadError == TRUE){
		return FALSE;
	}
	while(1)
	{
		ReadFile(hUSB, &in_buffer, ulBytesReadRequest, &ulBytesSucceed, NULL);

		if( (ulBytesSucceed != ulBytesReadRequest) && (m_bReadError == FALSE) )
		{
			m_bReadError = TRUE;	// Note: Set error flag immediately so that multiple 
								// message boxes do not queue up.

	//		printf("Error reading from USB.\nRead %d of %d bytes.\n\nApplication is aborting.\nReset hardware and try again.", ulBytesSucceed, ulBytesReadRequest);
	//		system("pause");
			return FALSE;
		}
		if(in_buffer[eadc_index] == (address))
		{
			*data = in_buffer[eupper_adc_result];
			*data = *data<<8;
			*data |= in_buffer[elower_adc_result];
			return TRUE;
		}
	}
}

BOOL WINAPI hid_close(HANDLE hUSB)
{
	return(CloseHandle(hUSB));
}

BOOL WINAPI hid_ResetHW(HANDLE hUSB)
{
	if(hUSB == INVALID_HANDLE_VALUE) return false;	
	
	Init_Mode = true;

    hid_write(hUSB,12,0);

	Init_Mode = false;
	
	return true;
}

BOOL WINAPI hid_SetInit(HANDLE hUSB, BYTE port1, BYTE port2, BYTE port3, BYTE port4, BOOL Is8PR, BYTE InOut)
{
	
	if(hUSB == INVALID_HANDLE_VALUE) return false;	
	
	Init_Mode = true;

	hid_write(hUSB,8,port1);
	hid_write(hUSB,9,port2);
	hid_write(hUSB,10,port3);
    hid_write(hUSB,11,port4);

	if(Is8PR) hid_write(hUSB,13,InOut);

	Init_Mode = false;
	
	return true;
}


BOOL WINAPI hid_EnableWD(HANDLE hUSB, BOOL enable)
{
	if(hUSB == INVALID_HANDLE_VALUE) return false;	
	
	Init_Mode = true;

	if(enable)
		hid_write(hUSB,14,1);
	else
		hid_write(hUSB,14,0);

	Init_Mode = false;
	
	return true;

}

BOOL WINAPI hid_SetWD(HANDLE hUSB, BYTE mode)
{
	if(hUSB == INVALID_HANDLE_VALUE) return false;	
	if(mode > 5 || mode < 1) return false;
	
	Init_Mode = true;

    hid_write(hUSB,15,mode);

	Init_Mode = false;
	
	return true;
}

BOOL WINAPI hid_ClearWD(HANDLE hUSB)
{
	if(hUSB == INVALID_HANDLE_VALUE) return false;	
	
	Init_Mode = true;

    hid_write(hUSB,16,0);

	Init_Mode = false;
	
	return true;

}

///////////////////////////////////////
//latch mode config:
//0x00:reset all counter
//0x01:reset all counter ,turn off latch mode
//0x02:reset all counter ,turn on latch mode,count edges
//0x03:reset all counter ,turn on latch mode,count positive edge
//0x04:reset all counter ,turn on latch mode,count negative edge
//0x0x:reset port.x counter
///////////////////////////////////////

BOOL WINAPI SetCounterMode (HANDLE hUSB, UINT address,BYTE command)//: i USB I/O board,  wchannel ] counter mode
{
	return hid_write(hUSB,0x30+address,command);
}

BOOL WINAPI ResetCounter (HANDLE hUSB, UINT address)//: Counter ks
{
	return hid_write(hUSB,0x30+address,0);
}

BOOL WINAPI GetCounter (HANDLE hUSB, UINT address, BYTE *data)//: Ū^pulse  ks
{
	BOOL flag;
	flag = hid_write(hUSB,0x35,address);
	if(flag == false)
		return FALSE;
	for(int i = 0;i<8;i++){
		flag = hid_read(hUSB,0x30 - eport1 + i,&(data[i]));
		if(flag == false)
			return FALSE;
	}
	flag = ResetCounter(hUSB,address);
	if(flag == false)
		return FALSE;
	return TRUE;
}

BOOL WINAPI SaveConfig(HANDLE hUSB)
{
	return hid_write(hUSB,0x3E,0x01);
}

/////////////////////////////////////////////////////////////////////////////////////////////
// 2009/08/26
// Serial Control

UINT UpdateCRC (UINT crc, BYTE newbyte)
{
   unsigned char i;                    // loop counter

   #define POLY 0x8408                 // CRC16-CCITT FCS (X^16+X^12+X^5+1)

   crc = crc ^ newbyte;

   for (i = 0; i < 8; i++)
   {
      if (crc & 0x01)
      {
         crc = crc >> 1;
         crc ^= POLY;
      }
      else
      {
         crc = crc >> 1;
      }
   }
   return crc;
}

BOOL WINAPI com_close(HANDLE hCom)
{

	com_card_id = 0;
	com_card_number = 0;

	return(CloseHandle(hCom));
}

BOOL write_com(HANDLE hCom, UINT address, BYTE data)
{
	unsigned int outCRC = 0x0000;
	unsigned char cTx;
	BOOL fSuccess;
	DWORD num;
	int cmd_lenth = 8,i;


	cTx = 6;			//packet head
//	outCRC = UpdateCRC(outCRC,cTx);

	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	cTx = 6;			//cmd
	outCRC = UpdateCRC(outCRC,cTx);
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	cTx = seg;			//seg

	if(seg == 0xFF)
	{
		seg = 0;
	}
	else
		seg++;
	

	outCRC = UpdateCRC(outCRC,cTx);
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	cTx = com_card_id;//0x0D;			//cardtype   

	outCRC = UpdateCRC(outCRC,cTx);
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	cTx = com_card_number; //0;			//cardid
	outCRC = UpdateCRC(outCRC,cTx);
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	cTx = address;			//address
	outCRC = UpdateCRC(outCRC,cTx);
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	cTx = data;			//data
	outCRC = UpdateCRC(outCRC,cTx);
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	for(i = 2;i<cmd_lenth;i++){
		cTx = 6;			//data
		outCRC = UpdateCRC(outCRC,cTx);
		fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);
	}
/*
	for(i = 0;i<cmd_lenth;i++){
		cTx = 6;			//data
		UpdateCRC(outCRC,cTx);
		fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);
	}
*/

	cTx = outCRC;			//crc1
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);
	cTx = outCRC >> 8;			//crc2
	fSuccess = WriteFile(hCom,&cTx,1,&num,NULL);

	// ??
	
	//com_read(hCom,0,&temp);

	return true;
}

BOOL read_com(HANDLE hCom, UINT address, BYTE *data)
{
	unsigned int inCRC = 0x0000 , inCRCtemp = 0x0000;
	BOOL fSuccess;
	DWORD num;
	const int MAXREAD = 12; // 11
	char cRx[MAXREAD];
	//char str[100];

	unsigned char rcardtype,rcardid,rp1,rp2,rp3,rp4,rp5;//,rcrc1,rcrc2;

	for(int i = 0;i<MAXREAD;i++){
		cRx[i] = ' ';
	}
	fSuccess = ReadFile(hCom,&cRx,MAXREAD,&num,NULL);

	if(!fSuccess) return false;

	if(fSuccess && (cRx[0] == 5)){		//head
		//status
		for(int i = 1;i<9;i++){
			inCRC = UpdateCRC(inCRC,cRx[i]);
		}
		//seg
		rseg = cRx[2];
		//cardtype
		rcardtype = cRx[3];
		//cardid
		rcardid = cRx[4];
		//p1
		rp1 = cRx[5];
		//p2
		rp2 = cRx[6];
		//p3
		rp3 = cRx[7];
		//p4
		rp4 = cRx[8];
		//FLASH_P5
		rp5 = cRx[9];
		//crc1
		inCRCtemp = cRx[10];
		inCRCtemp <<= 8;
		//crc2
		inCRCtemp += cRx[11];

/*
		int j;
		j = sprintf(str,"seg = %d,cardtype = %d,cardid = %d,\r\np1 = %x,p2 = %x,p3 = %x,p4 = %x",rseg,rcardtype,rcardid,rp1,rp2,rp3,rp4);
//		m_COMRXMsg.SetWindowText(str);
*/

		switch(address)
		{
		case 0:
			 *data = ((BYTE) rp1);
			break;

		case 1:
			 *data = ((BYTE) rp2);
			break;
		case 2:
			 *data = ((BYTE) rp3);
			break;
		case 3:
			 *data = ((BYTE) rp4);
			break;

		case 0x10:
			 *data = ((BYTE) rp5);
			break;

		case -1:
			 *data = ((BYTE) rcardtype);
			break;			

		case -2:
			 *data = ((BYTE) rcardid);
			break;
		}

	}
	else return false;
	/*
	{
		int j;
		j = sprintf(str,"not head,drop it");
	//	m_COMRXMsg.SetWindowText(str);
		//not head,drop it
	}
*/
	return true;
}

BOOL WINAPI com_write(HANDLE hCom, UINT address, BYTE data)
{
	BOOL fSuccess;
	BYTE temp;

	if(hCom == INVALID_HANDLE_VALUE) return false;

	//fSuccess = read_com(hCom,0,&temp);
	fSuccess = write_com(hCom,address,data);	
	
	if(!fSuccess) return false;
	
	fSuccess = read_com(hCom,0,&temp);

	//if(!fSuccess) return false;

	return true;
}


BOOL WINAPI com_read(HANDLE hCom, UINT address, BYTE *data)
{
	BOOL fSuccess;

	if(hCom == INVALID_HANDLE_VALUE) return false;

	fSuccess = write_com(hCom,5,0);

	//if(!fSuccess) return false;
	
	fSuccess = read_com(hCom, address,data);
	
	if(!fSuccess) return false;

	return true;
}


HANDLE WINAPI com_open(UINT card_id,UINT card_number,BYTE com_num)
{
	CString str;
	char commPort[20] = "\\\\.\\COM" ;
    char *pcCommPort = commPort;  //commPort;
	char tmp[100];
	int i = 0;
	DCB dcb;
	COMMTIMEOUTS timeouts = {0};
	BOOL fSuccess;
	HANDLE hCom;
	
	itoa(com_num,tmp,10);
	
	if(com_num <= 9 )
		strncat(commPort,tmp,1);
	else
		strncat(commPort,tmp,2);

    hCom = CreateFile( commPort,
					   GENERIC_READ | GENERIC_WRITE,
					   0,    // must be opened with exclusive-access
					   NULL, // no security attributes
					   OPEN_EXISTING, // must use OPEN_EXISTING
					   0,    // not overlapped I/O
					   NULL  // hTemplate must be NULL for comm devices
					   );

	com_card_id = card_id;
	com_card_number = card_number;

	timeouts.ReadIntervalTimeout = 40;
	timeouts.ReadTotalTimeoutConstant = 40;
	timeouts.ReadTotalTimeoutMultiplier = 40;
	timeouts.WriteTotalTimeoutConstant = 40;
	timeouts.WriteTotalTimeoutMultiplier = 40;

	if(hCom != INVALID_HANDLE_VALUE)
	{
	   fSuccess = SetCommTimeouts(hCom, &timeouts);
	   fSuccess = GetCommState(hCom, &dcb);

	   dcb.BaudRate = CBR_115200;     // set the baud rate
	   dcb.ByteSize = 8;             // data size, xmit, and rcv
	   dcb.Parity = NOPARITY;        // no parity bit
	   dcb.StopBits = ONESTOPBIT;    // one stop bit

       fSuccess = SetCommState(hCom, &dcb);

   
	   // check card id & card type

	   byte temp1,temp2;

	   com_read(hCom,-1, &temp1);
	   com_read(hCom,-2, &temp2);

	   if(card_id!=temp1 || card_number!=temp2) 
	   {	   
		  com_close(hCom);
	      return INVALID_HANDLE_VALUE;
	   }
	}

	seg = 0;

	return hCom;
}


// new define and add condition protection 


HANDLE WINAPI hid_OpenDevice(UINT card_id,UINT card_number)
{
	if(card_id > 15 || card_number > 256) return false;

	return hid_open(card_id,card_number);	
}

BOOL WINAPI hid_CloseDevice(HANDLE hUSB)
{
	return hid_close(hUSB);
}

BOOL WINAPI hid_GetDigitalByte(HANDLE hUSB, UINT address, BYTE *data)
{
	BOOL lResult;
	
	lResult = hid_read(hUSB,address,data);

	if(address == 0x10) *data = *data;
	else
	  *data = 255 - *data;

	return 	lResult;
}

BOOL WINAPI hid_SetDigitalByte(HANDLE hUSB, UINT address, BYTE data)
{
	if(address > 4) return false; 

	return hid_write(hUSB,address,data);	
}


BOOL WINAPI hid_GetDigitalBit(HANDLE hUSB, UINT address, BOOL *data)
{
    BOOL Result;
	BYTE inValue;
	BYTE wBit;     // which bit on one byte (bit 0~7)
	UINT dwPort;

	if(hUSB == INVALID_HANDLE_VALUE) return false;

	dwPort = address / 8;
	wBit = address % 8;

	Result = hid_read(hUSB,dwPort,&inValue);

	if(!Result)
		return FALSE;

	inValue = 255 - inValue;

	inValue = 0x01 & (inValue >> wBit);

	// return data
	if(!inValue)
		*data = FALSE;
	else
		*data = TRUE;
							
	return TRUE;
}

BOOL WINAPI hid_SetDigitalBit(HANDLE hUSB, UINT address, BOOL data)
{
    BYTE preValue;
    BYTE outValue;
	BOOL Result;
    BYTE wBit;
	DWORD dwPort;

	if(hUSB == INVALID_HANDLE_VALUE) return false;
		
	// traslate I/O line into the form that port and bit on port
	dwPort = address / 8;      
	wBit = address % 8;  

	//
	// read the data from the port which we will write data to
	//
	Result = hid_read(hUSB,dwPort,&preValue);

	preValue = 255 - preValue;

	if(!Result)
		return FALSE;

    if(data)  // input is True(1)
	{
        wBit = 1 << wBit;
        outValue = preValue | wBit; 
	} 
    else // input is False(0)
	{
        wBit = ~(1 << wBit); 
        outValue = preValue & wBit;
	}

	// write data to card

	Result = hid_write(hUSB,dwPort,outValue);

	if(!Result)
		return FALSE;	
    return TRUE;
}



HANDLE WINAPI com_OpenDevice(UINT card_id,UINT card_number,BYTE com_num)
{
	if(card_id > 14 || card_number > 256 || com_num > 256) return false;

	return com_open(card_id,card_number,com_num);	
}

BOOL WINAPI com_CloseDevice(HANDLE hCOM)
{
	return com_close(hCOM);
}

BOOL WINAPI com_GetDigitalByte(HANDLE hCOM, UINT address, BYTE *data)
{
	BOOL lResult;

	lResult = com_read(hCOM,address,data);

	if(address == 0x10) *data = *data;
	else
	  *data = 255 - *data;

	return 	lResult;	
}

BOOL WINAPI com_SetDigitalByte(HANDLE hCOM, UINT address, BYTE data)
{
	if(address > 4) return false; 

	return com_write(hCOM,address,data);	
}


BOOL WINAPI com_ResetHW(HANDLE hCOM)
{

	if(hCOM == INVALID_HANDLE_VALUE) return false;	

	com_write(hCOM,12,0);
	
	return true;
}



BOOL WINAPI com_GetDigitalBit(HANDLE hCOM, UINT address, BOOL *data)
{
    BOOL Result;
	BYTE inValue;
	BYTE wBit;     // which bit on one byte (bit 0~7)
	UINT dwPort;

	if(hCOM == INVALID_HANDLE_VALUE) return false;

	dwPort = address / 8;
	wBit = address % 8;

	Result = com_read(hCOM,dwPort,&inValue);

	if(!Result)
		return FALSE;

	inValue = 255 - inValue;

	inValue = 0x01 & (inValue >> wBit);

	// return data
	if(!inValue)
		*data = FALSE;
	else
		*data = TRUE;
							
	return TRUE;
}



BOOL WINAPI com_SetDigitalBit(HANDLE hCOM, UINT address, BOOL data)
{
    BYTE preValue;
    BYTE outValue;
	BOOL Result;
    BYTE wBit;
	DWORD dwPort;

	if(hCOM == INVALID_HANDLE_VALUE) return false;
		
	// traslate I/O line into the form that port and bit on port
	dwPort = address / 8;      
	wBit = address % 8;  

	//
	// read the data from the port which we will write data to
	//
	Result = com_read(hCOM,dwPort,&preValue);

	preValue = 255 - preValue;

	if(!Result)
		return FALSE;

    if(data)  // input is True(1)
	{
        wBit = 1 << wBit;
        outValue = preValue | wBit; 
	} 
    else // input is False(0)
	{
        wBit = ~(1 << wBit); 
        outValue = preValue & wBit;
	}

	// write data to card

	Result = com_write(hCOM,dwPort,outValue);

	if(!Result)
		return FALSE;	
    return TRUE;
}





#ifdef _MANAGED
#pragma managed(pop)
#endif
